"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = exports.compileCss = void 0;
/* eslint-disable @typescript-eslint/no-var-requires */
const pirates_1 = require("pirates");
const postcss_1 = __importDefault(require("postcss"));
const postcss_modules_sync_1 = __importDefault(require("postcss-modules-sync"));
const register_1 = require("@swc-node/register/register");
const read_default_tsconfig_1 = require("@swc-node/register/read-default-tsconfig");
function compileCss(code, filename) {
    let exportedTokens = {};
    const res = (0, postcss_1.default)([
        (0, postcss_modules_sync_1.default)({
            generateScopedName: '[path][local]-[hash:base64:10]',
            getJSON: (tokens) => {
                exportedTokens = tokens;
            },
        }),
    ]).process(code, { from: filename });
    // the below is required to properly resolve `exportedTokens`
    res
        .then(() => {
        // all good
    })
        .catch((e) => {
        throw new Error(`Cannot compile CSS ${e.message}`, e);
    });
    const js = `module.exports = JSON.parse('${JSON.stringify(exportedTokens)}');`;
    return {
        js,
        css: res.css,
    };
}
exports.compileCss = compileCss;
function compileJs(code, filename) {
    return compileCss(code, filename).js;
}
const register = () => {
    (0, pirates_1.addHook)((code, filename) => compileJs(code, filename), {
        exts: ['.css'],
    });
    let tsConfig = (0, read_default_tsconfig_1.readDefaultTsConfig)();
    tsConfig = {};
    (0, register_1.register)({ ...tsConfig });
};
exports.register = register;
//# sourceMappingURL=nodeCssRequire.js.map